# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['GrantViewArgs', 'GrantView']

@pulumi.input_type
class GrantViewArgs:
    def __init__(__self__, *,
                 database_name: pulumi.Input[str],
                 privilege: pulumi.Input[str],
                 role_name: pulumi.Input[str],
                 schema_name: pulumi.Input[str],
                 view_name: pulumi.Input[str]):
        """
        The set of arguments for constructing a GrantView resource.
        :param pulumi.Input[str] database_name: The database that the view belongs to.
        :param pulumi.Input[str] privilege: The privilege to grant to the object.
        :param pulumi.Input[str] role_name: The name of the role to grant privilege to.
        :param pulumi.Input[str] schema_name: The schema that the view being to.
        :param pulumi.Input[str] view_name: The view that is being granted on.
        """
        pulumi.set(__self__, "database_name", database_name)
        pulumi.set(__self__, "privilege", privilege)
        pulumi.set(__self__, "role_name", role_name)
        pulumi.set(__self__, "schema_name", schema_name)
        pulumi.set(__self__, "view_name", view_name)

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> pulumi.Input[str]:
        """
        The database that the view belongs to.
        """
        return pulumi.get(self, "database_name")

    @database_name.setter
    def database_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "database_name", value)

    @property
    @pulumi.getter
    def privilege(self) -> pulumi.Input[str]:
        """
        The privilege to grant to the object.
        """
        return pulumi.get(self, "privilege")

    @privilege.setter
    def privilege(self, value: pulumi.Input[str]):
        pulumi.set(self, "privilege", value)

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> pulumi.Input[str]:
        """
        The name of the role to grant privilege to.
        """
        return pulumi.get(self, "role_name")

    @role_name.setter
    def role_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "role_name", value)

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> pulumi.Input[str]:
        """
        The schema that the view being to.
        """
        return pulumi.get(self, "schema_name")

    @schema_name.setter
    def schema_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "schema_name", value)

    @property
    @pulumi.getter(name="viewName")
    def view_name(self) -> pulumi.Input[str]:
        """
        The view that is being granted on.
        """
        return pulumi.get(self, "view_name")

    @view_name.setter
    def view_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "view_name", value)


@pulumi.input_type
class _GrantViewState:
    def __init__(__self__, *,
                 database_name: Optional[pulumi.Input[str]] = None,
                 privilege: Optional[pulumi.Input[str]] = None,
                 role_name: Optional[pulumi.Input[str]] = None,
                 schema_name: Optional[pulumi.Input[str]] = None,
                 view_name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GrantView resources.
        :param pulumi.Input[str] database_name: The database that the view belongs to.
        :param pulumi.Input[str] privilege: The privilege to grant to the object.
        :param pulumi.Input[str] role_name: The name of the role to grant privilege to.
        :param pulumi.Input[str] schema_name: The schema that the view being to.
        :param pulumi.Input[str] view_name: The view that is being granted on.
        """
        if database_name is not None:
            pulumi.set(__self__, "database_name", database_name)
        if privilege is not None:
            pulumi.set(__self__, "privilege", privilege)
        if role_name is not None:
            pulumi.set(__self__, "role_name", role_name)
        if schema_name is not None:
            pulumi.set(__self__, "schema_name", schema_name)
        if view_name is not None:
            pulumi.set(__self__, "view_name", view_name)

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> Optional[pulumi.Input[str]]:
        """
        The database that the view belongs to.
        """
        return pulumi.get(self, "database_name")

    @database_name.setter
    def database_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "database_name", value)

    @property
    @pulumi.getter
    def privilege(self) -> Optional[pulumi.Input[str]]:
        """
        The privilege to grant to the object.
        """
        return pulumi.get(self, "privilege")

    @privilege.setter
    def privilege(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "privilege", value)

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the role to grant privilege to.
        """
        return pulumi.get(self, "role_name")

    @role_name.setter
    def role_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role_name", value)

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> Optional[pulumi.Input[str]]:
        """
        The schema that the view being to.
        """
        return pulumi.get(self, "schema_name")

    @schema_name.setter
    def schema_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "schema_name", value)

    @property
    @pulumi.getter(name="viewName")
    def view_name(self) -> Optional[pulumi.Input[str]]:
        """
        The view that is being granted on.
        """
        return pulumi.get(self, "view_name")

    @view_name.setter
    def view_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "view_name", value)


class GrantView(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_name: Optional[pulumi.Input[str]] = None,
                 privilege: Optional[pulumi.Input[str]] = None,
                 role_name: Optional[pulumi.Input[str]] = None,
                 schema_name: Optional[pulumi.Input[str]] = None,
                 view_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages the privileges on a Materailize view for roles.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_materialize as materialize

        # Grant SELECT to role example_role to view example_database.example_schema.example_view
        view_grant_select = materialize.GrantView("viewGrantSelect",
            database_name="example_database",
            privilege="SELECT",
            role_name="example_role",
            schema_name="example_schema",
            view_name="example_view")
        ```

        ## Import

        #Grants can be imported using the concatenation of GRANT, the object type, the id of the object, the id of the role and the privilege

        ```sh
         $ pulumi import materialize:index/grantView:GrantView example GRANT|VIEW|<view_id>|<role_id>|<privilege>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_name: The database that the view belongs to.
        :param pulumi.Input[str] privilege: The privilege to grant to the object.
        :param pulumi.Input[str] role_name: The name of the role to grant privilege to.
        :param pulumi.Input[str] schema_name: The schema that the view being to.
        :param pulumi.Input[str] view_name: The view that is being granted on.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GrantViewArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages the privileges on a Materailize view for roles.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_materialize as materialize

        # Grant SELECT to role example_role to view example_database.example_schema.example_view
        view_grant_select = materialize.GrantView("viewGrantSelect",
            database_name="example_database",
            privilege="SELECT",
            role_name="example_role",
            schema_name="example_schema",
            view_name="example_view")
        ```

        ## Import

        #Grants can be imported using the concatenation of GRANT, the object type, the id of the object, the id of the role and the privilege

        ```sh
         $ pulumi import materialize:index/grantView:GrantView example GRANT|VIEW|<view_id>|<role_id>|<privilege>
        ```

        :param str resource_name: The name of the resource.
        :param GrantViewArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GrantViewArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 database_name: Optional[pulumi.Input[str]] = None,
                 privilege: Optional[pulumi.Input[str]] = None,
                 role_name: Optional[pulumi.Input[str]] = None,
                 schema_name: Optional[pulumi.Input[str]] = None,
                 view_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GrantViewArgs.__new__(GrantViewArgs)

            if database_name is None and not opts.urn:
                raise TypeError("Missing required property 'database_name'")
            __props__.__dict__["database_name"] = database_name
            if privilege is None and not opts.urn:
                raise TypeError("Missing required property 'privilege'")
            __props__.__dict__["privilege"] = privilege
            if role_name is None and not opts.urn:
                raise TypeError("Missing required property 'role_name'")
            __props__.__dict__["role_name"] = role_name
            if schema_name is None and not opts.urn:
                raise TypeError("Missing required property 'schema_name'")
            __props__.__dict__["schema_name"] = schema_name
            if view_name is None and not opts.urn:
                raise TypeError("Missing required property 'view_name'")
            __props__.__dict__["view_name"] = view_name
        super(GrantView, __self__).__init__(
            'materialize:index/grantView:GrantView',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            database_name: Optional[pulumi.Input[str]] = None,
            privilege: Optional[pulumi.Input[str]] = None,
            role_name: Optional[pulumi.Input[str]] = None,
            schema_name: Optional[pulumi.Input[str]] = None,
            view_name: Optional[pulumi.Input[str]] = None) -> 'GrantView':
        """
        Get an existing GrantView resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] database_name: The database that the view belongs to.
        :param pulumi.Input[str] privilege: The privilege to grant to the object.
        :param pulumi.Input[str] role_name: The name of the role to grant privilege to.
        :param pulumi.Input[str] schema_name: The schema that the view being to.
        :param pulumi.Input[str] view_name: The view that is being granted on.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GrantViewState.__new__(_GrantViewState)

        __props__.__dict__["database_name"] = database_name
        __props__.__dict__["privilege"] = privilege
        __props__.__dict__["role_name"] = role_name
        __props__.__dict__["schema_name"] = schema_name
        __props__.__dict__["view_name"] = view_name
        return GrantView(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> pulumi.Output[str]:
        """
        The database that the view belongs to.
        """
        return pulumi.get(self, "database_name")

    @property
    @pulumi.getter
    def privilege(self) -> pulumi.Output[str]:
        """
        The privilege to grant to the object.
        """
        return pulumi.get(self, "privilege")

    @property
    @pulumi.getter(name="roleName")
    def role_name(self) -> pulumi.Output[str]:
        """
        The name of the role to grant privilege to.
        """
        return pulumi.get(self, "role_name")

    @property
    @pulumi.getter(name="schemaName")
    def schema_name(self) -> pulumi.Output[str]:
        """
        The schema that the view being to.
        """
        return pulumi.get(self, "schema_name")

    @property
    @pulumi.getter(name="viewName")
    def view_name(self) -> pulumi.Output[str]:
        """
        The view that is being granted on.
        """
        return pulumi.get(self, "view_name")

